package com.sun.corba.se.spi.protocol;

import org.omg.PortableInterceptor.PolicyFactory;
import org.omg.PortableInterceptor.Current;
import org.omg.PortableInterceptor.ORBInitInfoPackage.DuplicateName;
import org.omg.PortableInterceptor.Interceptor;
import org.omg.CORBA.PolicyError;
import org.omg.CORBA.Policy;
import org.omg.CORBA.Any;
import org.omg.CORBA.NVList;
import com.sun.corba.se.spi.ior.ObjectKeyTemplate;
import com.sun.corba.se.impl.protocol.giopmsgheaders.ReplyMessage;
import com.sun.corba.se.impl.corba.RequestImpl;
import org.omg.CORBA.portable.RemarshalException;
import org.omg.PortableInterceptor.ObjectReferenceTemplate;
import com.sun.corba.se.spi.oa.ObjectAdapter;
import java.io.Closeable;

public interface PIHandler extends Closeable
{
    public abstract void initialize();
    
    public abstract void destroyInterceptors();
    
    public abstract void objectAdapterCreated(ObjectAdapter p0);
    
    public abstract void adapterManagerStateChanged(int p0, short p1);
    
    public abstract void adapterStateChanged(ObjectReferenceTemplate[] p0, short p1);
    
    public abstract void disableInterceptorsThisThread();
    
    public abstract void enableInterceptorsThisThread();
    
    public abstract void invokeClientPIStartingPoint() throws RemarshalException;
    
    public abstract Exception invokeClientPIEndingPoint(int p0, Exception p1);
    
    public abstract Exception makeCompletedClientRequest(int p0, Exception p1);
    
    public abstract void initiateClientPIRequest(boolean p0);
    
    public abstract void cleanupClientPIRequest();
    
    public abstract void setClientPIInfo(RequestImpl p0);
    
    public abstract void setClientPIInfo(CorbaMessageMediator p0);
    
    public abstract void invokeServerPIStartingPoint();
    
    public abstract void invokeServerPIIntermediatePoint();
    
    public abstract void invokeServerPIEndingPoint(ReplyMessage p0);
    
    public abstract void initializeServerPIInfo(CorbaMessageMediator p0, ObjectAdapter p1, byte[] p2, ObjectKeyTemplate p3);
    
    public abstract void setServerPIInfo(Object p0, String p1);
    
    public abstract void setServerPIInfo(Exception p0);
    
    public abstract void setServerPIInfo(NVList p0);
    
    public abstract void setServerPIExceptionInfo(Any p0);
    
    public abstract void setServerPIInfo(Any p0);
    
    public abstract void cleanupServerPIRequest();
    
    public abstract Policy create_policy(int p0, Any p1) throws PolicyError;
    
    public abstract void register_interceptor(Interceptor p0, int p1) throws DuplicateName;
    
    public abstract Current getPICurrent();
    
    public abstract void registerPolicyFactory(int p0, PolicyFactory p1);
    
    public abstract int allocateServerRequestId();
}
